function mdl = buildhuman()
mdl = multibody;

leanangle = -5/180*pi;
legangle1 = 35/180*pi;
legangle2 = 30/180*pi;
swingspeed = -.8;
forwardspeed = 1.7;

% torso
mdl.makepart(floatjoint('parent', mdl.parts{1}, 'pos', [0; 0.5 + 1.3 * cos(leanangle); 0], 'q0', [0; 0; leanangle], 'dq0', [forwardspeed; 0; 0], 'name', 'origin'));
mdl.makepart(mass('parentname', 'origin', 'pos', [0; 1.35; 0],'m',[53.5; 53.5; 3], 'name', 'torso', 'drawsize', 0.09));

% left thigh
mdl.makepart(rotjoint('parentname', 'origin', 'pos', [0; 1; 0], 'name', 'lefthip', 'drawsize', 0.12, 'layer', -.25));
mdl.makepart(mass('parentname', 'lefthip', 'pos', [0; 0.80; 0],'m',[8.5,8.5,0.15], 'name', 'leftthigh', 'drawsize', 0.11, 'layer', -.25));
% left shank
mdl.makepart(rotjoint('parentname', 'lefthip', 'pos', [0; 0.5; 0], 'q0', leanangle, 'name', 'leftknee', 'drawsize', 0.07, 'layer', -.25));
mdl.makepart(mass('parentname', 'leftknee', 'pos', [0; 0.3; 0],'m',[3.5,3.5,0.05], 'name', 'leftshank', 'drawsize', 0.08, 'layer', -.25));
% left foot
mdl.makepart(rotjoint('parentname', 'leftknee', 'pos', [0; 0; 0], 'name', 'leftankle', 'drawsize', 0.05, 'layer', -.25));
mdl.makepart(mass('parentname', 'leftankle', 'pos', [0; .02; 0],'m',[1.25,1.25,0.005], 'name', 'leftfoot', 'drawsize', 0.02, 'layer', -.25));
mdl.makepart(point('parentname', 'leftankle', 'pos', [-.04; 0; 0], 'name', 'leftheel', 'drawsize', 0.02, 'layer', -.25));
mdl.makepart(point('parentname', 'leftankle', 'pos', [.16; 0; 0], 'name', 'lefttoe', 'drawsize', 0.02, 'layer', -.25));

% right thigh
mdl.makepart(rotjoint('parentname', 'origin', 'pos', [0; 1; 0], 'q0', legangle1, 'dq0', swingspeed, 'name', 'righthip', 'drawsize', 0.12, 'layer', .25));
mdl.makepart(mass('parentname', 'righthip', 'pos', [0; 0.80; 0],'m',[8.5,8.5,0.15], 'name', 'rightthigh', 'drawsize', 0.11, 'layer', .25));
% right shank
mdl.makepart(rotjoint('parentname', 'righthip', 'pos', [0; 0.5; 0], 'q0', legangle2, 'dq0', swingspeed, 'name', 'rightknee', 'drawsize', 0.07, 'layer', .25));
mdl.makepart(mass('parentname', 'rightknee', 'pos', [0; 0.3; 0],'m',[3.5,3.5,0.05], 'name', 'rightshank', 'drawsize', 0.08, 'layer', .25));
% right foot
mdl.makepart(rotjoint('parentname', 'rightknee', 'pos', [0; 0; 0], 'q0', legangle2, 'dq0', swingspeed, 'name', 'rightankle', 'drawsize', 0.05, 'layer', .25));
mdl.makepart(mass('parentname', 'rightankle', 'pos', [0; .02; 0],'m',[1.25,1.25,0.005], 'name', 'rightfoot', 'drawsize', 0.02, 'layer', .25));
mdl.makepart(point('parentname', 'rightankle', 'pos', [-.04; 0; 0], 'name', 'rightheel', 'drawsize', 0.02, 'layer', .25));
mdl.makepart(point('parentname', 'rightankle', 'pos', [.16; 0; 0], 'name', 'righttoe', 'drawsize', 0.02, 'layer', .25));

c = contact;
c.points = mdl.parts([10 11 18 19]);
mdl.makecontroller(c);

mdl.makecontroller(gravity);

c = ligamentssimple;
c.motors = mdl.parts([4 6 8 12 14 16]);
mdl.makecontroller(c);

c = reflex;
c.motors = mdl.parts([4 6 8 12 14 16]);
c.contacts = mdl.controllers{1};
mdl.makecontroller(c);

% c = xped;
% c.motors = mdl.parts([4 6 8 12 14 16]);
% mdl.makecontroller(c);
