/*
 * calcreflex.c
 *
 * Code generation for function 'calcreflex'
 *
 * C source code generated on: Tue Feb 12 16:45:19 2013
 *
 */

/* Include files */
#include "rt_nonfinite.h"
#include "rk4fixed.h"
#include "calcreflex.h"
#include "repmat.h"
#include "any.h"
#include "rk4fixed_data.h"

/* Type Definitions */

/* Named Constants */

/* Variable Declarations */

/* Variable Definitions */
static emlrtRSInfo n_emlrtRSI = { 120, "calcreflex",
  "D:/TMTmethod/simulator online/controllers/calcreflex.m" };

/* Function Declarations */

/* Function Definitions */
void calcreflex(real_T t, real_T N, const real_T pm[6], const real_T q[9], const
                real_T A[14], const real_T l_CE[14], const real_T s_filt[2],
                const real_T rec[50], real_T rec_out[50], const e_struct_T *c,
                const b_struct_T *r, const real_T fcglobal[36], real_T tm[6],
                real_T ds[30])
{
  boolean_T b1;
  boolean_T b2;
  boolean_T contacts[2];
  real_T qtheta_pto[2];
  int32_T i;
  real_T eps_SE;
  real_T w;
  real_T contactForce_idx_0;
  real_T contactForce_idx_1;
  real_T contactForceFilt[2];
  real_T S[14];
  int32_T iS;
  static const int8_T refi[6] = { 1, 4, 2, 5, 3, 6 };

  int32_T DSup;
  static const int8_T iv20[8] = { 0, 1, 2, 3, 7, 8, 9, 10 };

  static const int8_T iv21[6] = { 0, 1, 2, 7, 8, 9 };

  real_T maxval[14];
  real_T dA[14];
  real_T F_m_out[14];
  real_T F_CE[14];
  real_T b_pm[3];
  real_T c_pm[3];
  real_T dv7[21];
  real_T dv8[21];
  real_T b_refi[42];
  static const int8_T iv22[6] = { 0, 3, 1, 4, 2, 5 };

  real_T qmus[42];
  real_T phi[3];
  static const int8_T iv23[14] = { 1, 2, 3, 4, 5, 6, 7, 1, 2, 3, 4, 5, 6, 7 };

  real_T b_eps_SE;
  real_T F_SE;
  real_T f_l;
  real_T b_c[3];

  /* REFLEXCALCTORQUE calculates the outputs of the reflex model */
  b1 = any(*(real_T (*)[18])&fcglobal[0]);
  b2 = any(*(real_T (*)[18])&fcglobal[18]);
  contacts[0] = b1;
  contacts[1] = b2;
  if (N == 1.0) {
    qtheta_pto[0] = -q[2];
    qtheta_pto[1] = -q[2];
  } else {
    for (i = 0; i < 2; i++) {
      qtheta_pto[i] = rec[i + 28];
    }
  }

  /*  new implementation of the contact force, where the contact force is */
  /*  filtered */
  eps_SE = fcglobal[1];
  w = fcglobal[19];
  for (i = 0; i < 5; i++) {
    eps_SE += fcglobal[1 + 3 * (i + 1)];
    w += fcglobal[19 + 3 * (i + 1)];
  }

  contactForce_idx_0 = eps_SE / 800.0;
  contactForce_idx_1 = w / 800.0;
  contactForceFilt[0] = c->filt.C * s_filt[0] + c->filt.D * contactForce_idx_0;
  contactForceFilt[1] = c->filt.C * s_filt[1] + c->filt.D * contactForce_idx_1;

  /* % muscle dynamics */
  /*  torque vector */
  memset(&S[0], 0, 14U * sizeof(real_T));
  for (i = 0; i < 2; i++) {
    eps_SE = qtheta_pto[i];

    /*  loop left right */
    /*  check left foot contact and reflexes */
    iS = i * 7;
    if (contacts[i]) {
      /*  stance reflexes */
      eps_SE = -q[2];

      /*  check double support */
      if (contacts[1 - i] && (pm[refi[i] - 1] < pm[refi[1 - i] - 1])) {
        DSup = 1;
      } else {
        DSup = 0;
      }

      /*  calculate muscle stimulation, limit at 1 */
      S[iS] = c->S_0 + c->m[0].G * r->refForce_s[iS];

      /*  soleus */
      /*  tibialis: here the implementatione is slightly different from */
      /*  Geyer. Here the negative feedback is proportional to the average */
      /*  soleus and gastrocnemius torque instead of only the soleus */
      /*  torque. */
      S[iS + 1] = (c->S_0 + muDoubleScalarMax(0.0, c->m[1].G * (r->l_CE_s[iS + 1]
        - c->m[1].l_off))) - muDoubleScalarMax(0.0, c->m[1].G2 * (r->
        refForce_s[iS] + r->refForce_s[iS + 2]) / 2.0);

      /*  tibialis anterior (NEW) */
      /*          S(iS + 2) = c.S_0 ... */
      /*              + max(0, c.m(2).G * (r.l_CE_s(iS+2)-c.m(2).l_off)) ... */
      /*              - max(0, c.m(2).G2 * r.refForce_s(iS+1)); % tibialis anterior (ORIGINAL) */
      S[iS + 2] = c->S_0 + c->m[2].G * r->refForce_s[iS + 2];

      /*  gastrocnemius */
      S[iS + 3] = ((c->m[3].S_0 + c->m[3].G * r->refForce_m[iS + 3]) - c->k_phi *
                   (r->qrel_ref_m[refi[2 + i] - 1] - c->phi_knee_off) * (real_T)
                   (r->qrel_ref_m[refi[2 + i] - 1] > c->phi_knee_off) * (real_T)
                   (r->dqrel_ref_m[refi[2 + i] - 1] > 0.0)) - c->k_bw *
        muDoubleScalarAbs(contactForceFilt[1 - i]) * (real_T)DSup;

      /*  vastus */
      S[iS + 4] = c->S_0_bal + (c->k_p * (-r->q_ref_f[2] - c->theta_ref) +
        c->k_d * -r->dq_ref_f[2]) * c->k_bw * muDoubleScalarAbs
        (contactForceFilt[i]);

      /*  hamstring */
      S[iS + 5] = (c->S_0_bal + muDoubleScalarMax(0.0, 0.68 * c->k_p *
        (-r->q_ref_f[2] - c->theta_ref) + c->k_d * -r->dq_ref_f[2]) * c->k_bw *
                   muDoubleScalarAbs(contactForceFilt[i])) - c->dS * (real_T)
        DSup;

      /*  gluteus */
      S[iS + 6] = (c->S_0_bal - muDoubleScalarMin(0.0, c->k_p * (-r->q_ref_f[2]
        - c->theta_ref) + c->k_d * -r->dq_ref_f[2])) * c->k_bw *
        muDoubleScalarAbs(contactForceFilt[i]) + c->dS * (real_T)DSup;

      /*  hip flexor */
    } else {
      /*  swing reflexes */
      S[iS] = c->S_0;

      /*  soleus */
      S[iS + 1] = c->S_0 + c->m[1].G * (r->l_CE_s[iS + 1] - c->m[1].l_off);

      /*  tibialis anterior */
      S[iS + 2] = c->S_0;

      /*  gastrocnemius */
      S[iS + 3] = c->S_0;

      /*  vastus */
      S[iS + 4] = c->S_0 + c->m[4].G * r->refForce_f[iS + 4];

      /*  hamstring */
      S[iS + 5] = c->S_0 + c->m[5].G * r->refForce_f[iS + 5];

      /*  gluteus */
      S[iS + 6] = ((c->S_0 + muDoubleScalarMax(0.0, c->m[6].G * (r->l_CE_f[iS +
        6] - c->m[6].l_off))) - muDoubleScalarMax(0.0, c->m[6].G2 * (r->
        l_CE_f[iS + 4] - c->m[4].l_off))) + c->k_lean * (qtheta_pto[i] -
        c->theta_ref);

      /*  hip flexor */
    }

    /*  stance swing reflexes */
    emlrtBreakCheckFastR2012b(emlrtBreakCheckR2012bFlagVar, emlrtRootTLSGlobal);
    qtheta_pto[i] = eps_SE;
  }

  /*  loop left right */
  for (iS = 0; iS < 14; iS++) {
    eps_SE = S[iS] + S[iS] * (rec_out[iS + 30] * c->maxnoise);
    S[iS] = eps_SE;
  }

  for (i = 0; i < 14; i++) {
    S[i] = muDoubleScalarMin(1.0, muDoubleScalarMax(0.01, S[i]));
  }

  if (t <= c->dt_f) {
    for (i = 0; i < 14; i++) {
      S[i] = 0.01;
    }
  } else if (t <= c->dt_m) {
    for (iS = 0; iS < 8; iS++) {
      S[iv20[iS]] = 0.01;
    }
  } else {
    if (t <= c->dt_s) {
      for (iS = 0; iS < 6; iS++) {
        S[iv21[iS]] = 0.01;
      }
    }
  }

  emlrtPushRtStackR2012b(&n_emlrtRSI, emlrtRootTLSGlobal);

  /* LOOPMUSCLES Summary of this function goes here */
  /*    Detailed explanation goes here */
  for (i = 0; i < 14; i++) {
    maxval[i] = 0.0;
    dA[i] = 0.0;
    F_m_out[i] = 0.0;
    F_CE[i] = 0.0;
  }

  for (i = 0; i < 6; i++) {
    tm[i] = 0.0;
  }

  for (iS = 0; iS < 3; iS++) {
    b_pm[iS] = 4.0 + (real_T)iS;
    c_pm[iS] = 1.0 + (real_T)iS;
  }

  repmat(b_pm, dv7);
  repmat(c_pm, dv8);
  for (iS = 0; iS < 3; iS++) {
    for (i = 0; i < 7; i++) {
      b_refi[i + 14 * iS] = dv8[i + 7 * iS];
    }

    for (i = 0; i < 7; i++) {
      b_refi[(i + 14 * iS) + 7] = dv7[i + 7 * iS];
    }

    b_pm[iS] = pm[iv22[1 + (iS << 1)]];
    c_pm[iS] = pm[iv22[iS << 1]];
  }

  repmat(b_pm, dv7);
  repmat(c_pm, dv8);
  for (iS = 0; iS < 3; iS++) {
    for (i = 0; i < 7; i++) {
      qmus[i + 14 * iS] = dv8[i + 7 * iS];
    }

    for (i = 0; i < 7; i++) {
      qmus[(i + 14 * iS) + 7] = dv7[i + 7 * iS];
    }
  }

  for (i = 0; i < 14; i++) {
    for (iS = 0; iS < 3; iS++) {
      phi[iS] = qmus[i + 14 * iS];
    }

    /* MUSCLE calculates the muscle dynamics according to [1] and [2]. */
    /*    INPUT: */
    /*    m: muscle parameters (struct) */
    /*    phi: joint angles [3 by 1 rad] */
    /*    l_CE: length of contractive element [m] */
    /*    A: muscle activation [] */
    /*    S: muscle stimulation [] */
    /*    OUTPUT: */
    /*    v_CE: velocity of contractive element [m/s] */
    /*    dA: derivative of muscle activation [/s] */
    /*    tau_m: muscle torque [3 by 1 rad] */
    /*    F_m: muscle force [N] */
    /*    [1] Geyer, H. and H. Herr (2010). "A muscle-reflex model that encodesl_ */
    /*    principles of legged mechanics produces human walking dynamics and */
    /*    muscle activities." Neural Systems and Rehabilitation Engineering, IEEE */
    /*    Transactions on 18(3): 263-273. */
    /*    [2] Geyer, H., A. Seyfarth, et al. (2003). "Positive force feedback in  */
    /*    bouncing gaits?" Proceedings of the Royal Society of London. Series B:  */
    /*    Biological Sciences 270(1529): 2173. */
    /* % model parameters */
    /*  fixed model parameters */
    /*  eccentric force enehancement [] */
    /*  cusvature constant [] */
    /*  refernece strain of the series elastic element [] */
    w = 0.56 * c->m[iv23[i] - 1].l_opt;

    /*  width [m] */
    /*  residual force factor */
    /*  exitation contraction coupling constant [s] */
    /*  lenght properties MTU */
    /*  r = [m.r0(1); m.r0(2:3).*cos(phi(2:3)-m.phi_max(2:3))]; % effective lever arm */
    /*  deflection of the muscle */
    /*  total length of the muscle tendon unit */
    /*  length of the series elastic element */
    /* % activation dynamics */
    /* % series elastic element */
    eps_SE = ((((c->m[iv23[i] - 1].l_opt + c->m[iv23[i] - 1].l_slack) + c->
                m[iv23[i] - 1].dir * ((c->m[iv23[i] - 1].rho * c->m[iv23[i] - 1]
      .r0[0] * (phi[0] - c->m[iv23[i] - 1].phi_ref[0]) + c->m[iv23[i] - 1].rho *
      c->m[iv23[i] - 1].r0[1] * (muDoubleScalarSin(phi[1] - c->m[iv23[i] - 1].
      phi_max[1]) - muDoubleScalarSin(c->m[iv23[i] - 1].phi_ref[1] - c->m[iv23[i]
      - 1].phi_max[1]))) + c->m[iv23[i] - 1].rho * c->m[iv23[i] - 1].r0[2] *
      (muDoubleScalarSin(phi[2] - c->m[iv23[i] - 1].phi_max[2]) -
       muDoubleScalarSin(c->m[iv23[i] - 1].phi_ref[2] - c->m[iv23[i] - 1].
                         phi_max[2])))) - l_CE[i]) - c->m[iv23[i] - 1].l_slack) /
      c->m[iv23[i] - 1].l_slack;
    if (eps_SE > 0.0) {
      b_eps_SE = muDoubleScalarPower(eps_SE / 0.04, 2.0);
    } else {
      b_eps_SE = 0.0;
    }

    F_SE = b_eps_SE * c->m[iv23[i] - 1].F_max;

    /* % buffer element */
    /*  buffer element only exites if compressed */
    /* % paralel element */
    /*  paralel element only exites if tensioned */
    /* % contractile element */
    /*  force length relationship */
    f_l = muDoubleScalarExp(-2.9957322735539909 * muDoubleScalarPower
      (muDoubleScalarAbs((l_CE[i] - c->m[iv23[i] - 1].l_opt) / w), 3.0));

    /*  output value based on force length relationship */
    w = (F_SE + c->m[iv23[i] - 1].F_max * muDoubleScalarPower(muDoubleScalarMin
          (0.0, l_CE[i] - (c->m[iv23[i] - 1].l_opt - w)) / (w / 2.0), 2.0)) /
      (A[i] * c->m[iv23[i] - 1].F_max * f_l + c->m[iv23[i] - 1].F_max *
       muDoubleScalarPower(muDoubleScalarMax(0.0, l_CE[i] - c->m[iv23[i] - 1].
         l_opt) / w, 2.0));

    /*  % force length relationship (NOT USED) */
    /*  if v_CE < 0 */
    /*      f_v = (m.v_max-v_CE)/(m.v_max+K*v_CE); */
    /*  else */
    /*      f_v = N + (N+1) * (m.v_max + v_CE)/(-m.v_max+7.56*K*v_CE); */
    /*  end */
    /*  inverse force velocity relationship */
    if (w <= 1.0) {
      eps_SE = c->m[iv23[i] - 1].v_max * (1.0 - w) / (5.0 * w + 1.0);
    } else if ((w > 1.0) && (w <= 1.5)) {
      eps_SE = (w - 1.5) / 0.5;
      eps_SE = c->m[iv23[i] - 1].v_max * (1.0 + eps_SE) / (37.8 * eps_SE - 1.0);
    } else {
      /*      v_CE = -m.v_max;  */
      eps_SE = (w - 1.5) * 0.01 - c->m[iv23[i] - 1].v_max;
    }

    /*  muscle force and joint torque */
    /*  muscle force */
    /*  joint torque */
    maxval[i] = eps_SE;
    dA[i] = (S[i] - A[i]) / 0.01;
    F_m_out[i] = F_SE;
    F_CE[i] = A[i] * w * f_l * c->m[iv23[i] - 1].F_max;
    F_SE *= c->m[iv23[i] - 1].dir;
    b_c[0] = c->m[iv23[i] - 1].r0[0];
    b_c[1] = c->m[iv23[i] - 1].r0[1] * muDoubleScalarCos(phi[1] - c->m[iv23[i] -
      1].phi_max[1]);
    b_c[2] = c->m[iv23[i] - 1].r0[2] * muDoubleScalarCos(phi[2] - c->m[iv23[i] -
      1].phi_max[2]);
    for (iS = 0; iS < 3; iS++) {
      b_pm[iS] = tm[(int32_T)b_refi[i + 14 * iS] - 1] + b_c[iS] * F_SE;
    }

    for (iS = 0; iS < 3; iS++) {
      tm[(int32_T)b_refi[i + 14 * iS] - 1] = b_pm[iS];
    }

    emlrtBreakCheckFastR2012b(emlrtBreakCheckR2012bFlagVar, emlrtRootTLSGlobal);
  }

  emlrtPopRtStackR2012b(&n_emlrtRSI, emlrtRootTLSGlobal);
  for (iS = 0; iS < 6; iS++) {
    tm[iS] = -tm[iS];
  }

  /*  extra state derivative output */
  memcpy(&ds[0], &dA[0], 14U * sizeof(real_T));
  memcpy(&ds[14], &maxval[0], 14U * sizeof(real_T));
  ds[28] = c->filt.A * s_filt[0] + c->filt.B * contactForce_idx_0;
  ds[29] = c->filt.A * s_filt[1] + c->filt.B * contactForce_idx_1;
  for (i = 0; i < 14; i++) {
    rec_out[i] = F_m_out[i];
  }

  for (i = 0; i < 14; i++) {
    rec_out[i + 14] = F_CE[i];
  }

  for (i = 0; i < 2; i++) {
    rec_out[i + 28] = qtheta_pto[i];
  }

  for (i = 0; i < 6; i++) {
    rec_out[i + 44] = tm[i];
  }
}

/* End of code generation (calcreflex.c) */
