/*
 * power.c
 *
 * Code generation for function 'power'
 *
 * C source code generated on: Thu Aug 30 14:03:55 2012
 *
 */

/* Include files */
#include "rt_nonfinite.h"
#include "testspline.h"
#include "power.h"

/* Type Definitions */

/* Named Constants */

/* Variable Declarations */

/* Variable Definitions */

/* Function Declarations */

/* Function Definitions */

creal_T power(const creal_T a, real_T b)
{
    creal_T y;
    real_T t_re;
    real_T t_im;
    int8_T r;
    if ((a.im == 0.0) && (a.re >= 0.0)) {
        y.re = muDoubleScalarPower(a.re, b);
        y.im = 0.0;
    } else if ((a.re == 0.0) && (muDoubleScalarFloor(b) == b) && (muDoubleScalarAbs(b) <= 9.007199254740991E+15)) {
        t_re = muDoubleScalarPower(a.im, b);
        t_im = b - muDoubleScalarFloor(b / 4.0) * 4.0;
        t_im = t_im < 0.0 ? muDoubleScalarCeil(t_im - 0.5) : muDoubleScalarFloor(t_im + 0.5);
        if (t_im < 128.0) {
            if (t_im >= -128.0) {
                r = (int8_T)t_im;
            } else {
                r = MIN_int8_T;
            }
        } else if (t_im >= 128.0) {
            r = MAX_int8_T;
        } else {
            r = 0;
        }
        if (r == 3) {
            y.re = 0.0;
            y.im = -t_re;
        } else if (r == 2) {
            y.re = -t_re;
            y.im = 0.0;
        } else if (r == 1) {
            y.re = 0.0;
            y.im = t_re;
        } else {
            y.re = t_re;
            y.im = 0.0;
        }
    } else {
        t_re = a.re;
        t_im = a.im;
        if ((a.im == 0.0) && muDoubleScalarIsNaN(a.re)) {
        } else if ((muDoubleScalarAbs(a.re) > 8.9884656743115785E+307) || (muDoubleScalarAbs(a.im) > 8.9884656743115785E+307)) {
            t_re = muDoubleScalarAbs(a.re / 2.0);
            t_im = muDoubleScalarAbs(a.im / 2.0);
            if (t_re < t_im) {
                t_re /= t_im;
                t_im *= muDoubleScalarSqrt(t_re * t_re + 1.0);
            } else if (t_re > t_im) {
                t_im /= t_re;
                t_im = muDoubleScalarSqrt(t_im * t_im + 1.0) * t_re;
            } else if (muDoubleScalarIsNaN(t_im)) {
            } else {
                t_im = t_re * 1.4142135623730951;
            }
            t_re = muDoubleScalarLog(t_im) + 0.69314718055994529;
            t_im = muDoubleScalarAtan2(a.im, a.re);
        } else {
            t_re = muDoubleScalarAbs(a.re);
            t_im = muDoubleScalarAbs(a.im);
            if (t_re < t_im) {
                t_re /= t_im;
                t_im *= muDoubleScalarSqrt(t_re * t_re + 1.0);
            } else if (t_re > t_im) {
                t_im /= t_re;
                t_im = muDoubleScalarSqrt(t_im * t_im + 1.0) * t_re;
            } else if (muDoubleScalarIsNaN(t_im)) {
            } else {
                t_im = t_re * 1.4142135623730951;
            }
            t_re = muDoubleScalarLog(t_im);
            t_im = muDoubleScalarAtan2(a.im, a.re);
        }
        t_re *= b;
        t_im *= b;
        t_re = muDoubleScalarExp(t_re);
        y.re = t_re * muDoubleScalarCos(t_im);
        y.im = t_re * muDoubleScalarSin(t_im);
    }
    return y;
}
/* End of code generation (power.c) */
