classdef ankletorque < controller
    %REVERSELEG Calculates the jacobian for the reversed leg
    %   Detailed explanation goes here
    
    properties
        gaitpatterngraph
    end
    
    methods
        function c = ankletorque(mdl)
            c.name = 'ankle_torque';
            c.cons.stiffness = 100;
            c.cons.tension = 0.001;
            c.rec = 10;
            c.s = 2;
            c.s0 = [0;0];
        end
        
        function writebody(c, file_id, mdl)
            fprintf(file_id, ['rec = rec_in(' mat2str(c.recid) ', max(1, N-1)); \n']);
            fprintf(file_id, ['s = s_in(' mat2str(c.sid) '); \n']);
            fprintf(file_id, ['gpg = rec_in(' mat2str(c.gaitpatterngraph.recid) ', max(1, N-1)); \n']);
            fprintf(file_id, '[mt ds rec_out] = calcankletorque(t, q, dq, s, rec, pm, vm, Tj, dTj, gpg, cons); \n');
        end
        
        function c = initsim(c, mdl)
            [c.cons.CoM c.cons.mt] = centreofmass(mdl); % set cetre of mass and total mass total mass
            c.cons.omega0 = sqrt(9.81/c.cons.CoM(2));
        end
    end    
end

