function [mt rec_out] = calcffgaitpattern(phase, t, cons)
% CALCFFGAITPATTERN id a function related to FFGAITPATTERN that calculates
% the torques to be assigned by the controller.
%#codegen

mt = zeros(6, 1);

cGain = cons.on * max(0, min(1, (t - cons.tOn)/cons.tSwitch));

% interpolate the torques from a database and assign them to the human body
% joints
wsign = [-1 1 -1]; % corrct for the sign of the Winter torques

mt(cons.winterjoints) = ...
    cons.weight * interpfast(phase/(2*pi), cons.w.t(2), cons.w.t, cons.w.T(:, cons.winterjoints)') .* wsign(cons.winterjoints) * cGain;
mt(cons.winterjoints + 3) = ...
    cons.weight * interpfast(mod(phase/(2*pi)+0.5,1), cons.w.t(2), cons.w.t, cons.w.T(:, cons.winterjoints)') .* wsign(cons.winterjoints) * cGain;

% record the applied torques
rec_out = mt;

end

