classdef contact < controller
    %CONTACT Summary of this class goes here
    %   Detailed explanation goes here
    
    properties
        FyMax = 5000; % maximal upward force
        Ky      = 5e8;  % [1x1] contact model stiffness
        Dy      = 1e5;  % [1x1] contact model damping
        Dx      = 5e2;  % [1x1] contact model damping
        friccof = 1.5;    % [1x1] contact model friction coefficient % used to be 7
    end
    
    methods
        function c = contact
            c.name = 'contactforce';
            addlistener(c,'points','PostSet',@c.pointassigned);
        end
        
        function writebody(c, file_id, mdl)           
            fprintf(file_id, 'dxy = dTp*dq; \n');
            
            fprintf(file_id, 'Fc = zeros(length(Tp), 1); \n');
            
            for ipoint = 1:length(c.points)
                fprintf(file_id, ['y = min(0, Tp(' num2str(ipoint * 3 - 1) ')); \n']);
                fprintf(file_id, ['dx = dxy(' num2str(ipoint * 3 - 2) '); \n']);
                fprintf(file_id, ['dy = dxy(' num2str(ipoint * 3 - 1) '); \n']);

                fprintf(file_id, ['Fc(' num2str(ipoint * 3 - 1) ') = max(0,  min(' num2str(c.Ky) ' * (-(y^3) + dy * y^3), ' num2str(c.FyMax) ')); \n']);
                fprintf(file_id, ['Fx = ' num2str(-c.Dx) ' * dx; \n']);
                fprintf(file_id, ['FxMax = Fc(' num2str(ipoint * 3 - 1) ') * ' num2str(c.friccof) '; \n']);
                fprintf(file_id, ['Fc(' num2str(ipoint * 3 - 2) ') = sign(Fx)*min(abs(Fx),abs(FxMax)); \n']);
            end
            fprintf(file_id, 'rec_out = Fc; \n');
            fprintf(file_id, 'F = dTp'' * Fc; \n');
        end
        
        function pointassigned(p, src, evnt)
            p.rec = length(p.points) * 3;
        end
        
        function c = initsim(c, mdl)
        end
    end
    
end

