function cons = initreflex
%INITREFLEX is an initialization file for the muscle parameters
%% muscle parameters
% soleus
cons.m(1).name = 'soleus'; % muscle name
cons.m(1).F_max = 4000; % maximal force [N]
cons.m(1).l_opt = 0.04; % optimum lenght [m]
cons.m(1).l_slack = 0.26; % slack lenght [m]
cons.m(1).v_max = -6*cons.m(1).l_opt; % maximal shortening velocity [m/s]
cons.m(1).r0 = [0; 0; 0.05]; % attachment radius [m]
cons.m(1).phi_max = [0; 0; -20] * (pi/180); % maximal joint angle [rad]
cons.m(1).phi_ref = [0; 0; 10] * (pi/180); % reference joint angle [rad]
cons.m(1).dir = 1; % direction of the muscle
cons.m(1).rho = 0.5; % muscle penation angle correction
cons.m(1).l_off = 0; % NOT USED
cons.m(1).G = 1.088 / cons.m(1).F_max; % muscle reflex gain % Original 1.2
cons.m(1).G2 = 0; % NOT USED
cons.m(1).S_0 = 0; % NOT USED

% tibialis anterior
cons.m(2).name = 'tibialis anterior'; % muscle name
cons.m(2).F_max = 800; % maximal force [N]
cons.m(2).l_opt = 0.06; % optimum lenght [m]
cons.m(2).l_slack = 0.24; % slack lenght [m]
cons.m(2).v_max = -12*cons.m(2).l_opt; % maximal shortening velocity [m/s]
cons.m(2).r0 = [0; 0; 0.04]; % attachment radius [m]
cons.m(2).phi_max = [0; 0; 10] * (pi/180); % maximal joint angle [rad]
cons.m(2).phi_ref = [0; 0; -20] * (pi/180); % reference joint angle [rad]
cons.m(2).rho = 0.7; % muscle penation angle correction
cons.m(2).dir = -1; % direction of the muscle
cons.m(2).l_off = 0.71*cons.m(2).l_opt; % length offset
cons.m(2).G = 1.1/cons.m(2).l_opt; % muscle reflex gain
cons.m(2).G2 = 1.1/cons.m(1).F_max; % muscle reflex gain soleus - tibialis anterior coupling
cons.m(2).S_0 = 0; % NOT USED

% gastrocnemius
cons.m(3).name = 'gastrocnemius'; % muscle name
cons.m(3).F_max = 1500; % maximal force [N]
cons.m(3).l_opt = 0.05; % optimum lenght [m]
cons.m(3).l_slack = 0.40; % slack lenght [m]
cons.m(3).v_max = -12*cons.m(3).l_opt; % maximal shortening velocity [m/s]
cons.m(3).r0 = [0; 0.05; 0.05]; % attachment radius [m]
cons.m(3).phi_max = [0; -40; -20] * (pi/180); % maximal joint angle [rad]
cons.m(3).phi_ref = [0; -15; 10] * (pi/180); % reference joint angle [rad]
cons.m(3).rho = 0.7; % muscle penation angle correction
cons.m(3).dir = 1; % direction of the muscle
cons.m(3).l_off = 0; % NOT USED
cons.m(3).G = 3.3 / cons.m(3).F_max; % muscle reflex gain % Original 1.1
cons.m(3).G2 = 0; % NOT USED
cons.m(3).S_0 = 0; % NOT USED

% vastus
cons.m(4).name = 'vastus'; % muscle name
cons.m(4).F_max = 6000; % maximal force [N]
cons.m(4).l_opt = 0.08; % optimum lenght [m]
cons.m(4).l_slack = 0.23; % slack lenght [m]
cons.m(4).v_max = -12*cons.m(4).l_opt; % maximal shortening velocity [m/s]
cons.m(4).r0 = [0; 0.06; 0]; % attachment radius [m]
cons.m(4).phi_max = [0; -15; 0] * (pi/180); % maximal joint angle [rad]
cons.m(4).phi_ref = [0; -55; 0] * (pi/180); % reference joint angle [rad]
cons.m(4).rho = 0.7; % muscle penation angle correction
cons.m(4).dir = -1; % direction of the muscle
cons.m(4).l_off = 0; % NOT USED
cons.m(4).G = 1.15 / cons.m(4).F_max; % muscle reflex gain
cons.m(4).G2 = 0; % NOT USED
cons.m(4).S_0 = 0.08; % initial stimulation % in model 0.08 in artikel 0.09

% hamstring
cons.m(5).name = 'hamstring'; % muscle name
cons.m(5).F_max = 3000; % maximal force [N]
cons.m(5).l_opt = 0.10; % optimum lenght [m]
cons.m(5).l_slack = 0.31; % slack lenght [m]
cons.m(5).v_max = -12*cons.m(5).l_opt; % maximal shortening velocity [m/s]
cons.m(5).r0 = [0.08; 0.05; 0]; % attachment radius [m]
cons.m(5).phi_max = [NaN; 0; 0] * (pi/180); % maximal joint angle [rad]
cons.m(5).phi_ref = [25; 0; 0] * (pi/180); % reference joint angle [rad]
cons.m(5).rho = 0.7; % muscle penation angle correction
cons.m(5).dir = 1; % direction of the muscle
cons.m(5).l_off = 0.85*cons.m(5).l_opt; % length offset
cons.m(5).G = 0.65 / cons.m(5).F_max; % muscle reflex gain 
cons.m(5).G2 = 0; % NOT USED
cons.m(5).S_0 = 0; % NOT USED

% gluteus
cons.m(6).name = 'gluteus'; % muscle name
cons.m(6).F_max = 1500; % maximal force [N]
cons.m(6).l_opt = 0.11; % optimum lenght [m]
cons.m(6).l_slack = 0.13; % slack lenght [m]
cons.m(6).v_max = -12*cons.m(6).l_opt; % maximal shortening velocity [m/s]
cons.m(6).r0 = [0.1; 0; 0]; % attachment radius [m]
cons.m(6).phi_max = [NaN; 0; 0] * (pi/180); % maximal joint angle [rad]
cons.m(6).phi_ref = [30; 0; 0] * (pi/180); % reference joint angle [rad]
cons.m(6).rho = 0.5; % muscle penation angle correction
cons.m(6).dir = 1; % direction of the muscle
cons.m(6).l_off = 0; % NOT USED
cons.m(6).G = 0.4 / cons.m(6).F_max; % muscle reflex gain
cons.m(6).G2 = 0; % NOT USED
cons.m(6).S_0 = 0; % NOT USED

% hip flexors
cons.m(7).name = 'hip flexors'; % muscle name
cons.m(7).F_max = 2000; % maximal force [N]
cons.m(7).l_opt = 0.11; % optimum lenght [m]
cons.m(7).l_slack = 0.10; % slack lenght [m]
cons.m(7).v_max = -12*cons.m(7).l_opt; % maximal shortening velocity [m/s]
cons.m(7).r0 = [0.1; 0; 0]; % attachment radius [m]
cons.m(7).phi_max = [NaN; 0; 0] * (pi/180); % maximal joint angle [rad]
cons.m(7).phi_ref = [0; 0; 0] * (pi/180); % reference joint angle [rad]
cons.m(7).rho = 0.5; % muscle penation angle correction
cons.m(7).dir = -1; % direction of the muscle
cons.m(7).G = 1.4 / cons.m(7).l_opt; % muscle reflex gain (in paper 0.35)
cons.m(7).S_0 = 0; % NOT USED
cons.m(7).l_off = 0.6*cons.m(7).l_opt; % length offset (in paper 0.6 in model 0.65)
cons.m(7).G2 = 4 / cons.m(5).l_opt; % gain hamstring-hip flexor coupling
end

