classdef phasedetect < controller
    % PHASEDETECT performes phase detection. Intended for phase detection
    % on a human subject.
       
    properties
        contacts = [];
    end
    
    methods
        function c = phasedetect()
            c.name = 'phase_detect';
            
            c.cons.eps = 10;
            c.cons.nu = 5;
            
            c.s = 4; % number of states of the controller
            c.s0 = [0; 1.2*2*pi; 0; 0];
            c.rec = 2; % number of recorded values
        end
        
        function writebody(c, file_id, mdl)
            fprintf(file_id, ['s = s_in(' mat2str(c.sid) '); \n']);
            fprintf(file_id, ['rec = rec_in(' mat2str(c.recid) ', max(1, N-1)); \n']);
            fprintf(file_id, ['fcglobal1 = rec_in(' mat2str(c.contacts.recid) ', max(1, N-1)); \n']); % ground contacts at timestep N-1
            fprintf(file_id, ['fcglobal0 = rec_in(' mat2str(c.contacts.recid) ', max(1, N-2)); \n']); % ground contacts at timestep N-2
            fprintf(file_id, '[mt ds rec_out] = calcphasedetect(t, pm, s, rec, cons, fcglobal0, fcglobal1); \n');
        end
        
        function initsim(c, ~)
        end
        
    end
    
end

