function makeCmatrices(mdl)
%MAKEMATRICES Summary of this function goes here
%   Detailed explanation goes here

file_id = fopen(fullfile('generated',[mdl.prefix 'Cmatrices.m']), 'w'); % open file

%% write the header
fprintf(file_id, 'function [dDc ddDc] = Cmatrices(q, dq, p_in, c_in)\n'); % write file header
fprintf(file_id, '%%#codegen \n');
%% process the inputs
% process the q and dq input
nq = 0;
for ijoint = mdl.joints
    for iq = 1:length(mdl.parts{ijoint}.q);
        nq = nq + 1;
        fprintf(file_id, [mdl.parts{ijoint}.q{iq} ' = q(' num2str(nq) '); \n']);
        fprintf(file_id, [mdl.parts{ijoint}.dq{iq} ' = dq(' num2str(nq) '); \n']);
    end
end

% process the initial positions of the joints (t_in, m_in, p_in)
for ipart = 1:length(mdl.joints)
    ijmp = mdl.joints(ipart);
    fprintf(file_id, ['l_' mdl.parts{ijmp}.name ' = p_in(' num2str(ipart) ', 1); \n']);
    fprintf(file_id, ['theta_' mdl.parts{ijmp}.name ' = p_in(' num2str(ipart) ', 2); \n']);
end

for icons = 1:length(mdl.constraints)
    icons2 = mdl.constraints(icons);
    fprintf(file_id, ['l_' mdl.parts{icons2}.name '_1 = c_in(' num2str(icons) ', 1); \n']);
    fprintf(file_id, ['theta_' mdl.parts{icons2}.name '_1 = c_in(' num2str(icons) ', 2); \n']);
    fprintf(file_id, ['l_' mdl.parts{icons2}.name '_2 = c_in(' num2str(icons) ', 3); \n']);
    fprintf(file_id, ['theta_' mdl.parts{icons2}.name '_2 = c_in(' num2str(icons) ', 4); \n']);
end

%% make the empty matrices
fprintf(file_id, ['dDc = zeros(' num2str(length(mdl.constraints) * 2) ', ' num2str(nq) ');\n']);
fprintf(file_id, ['ddDc = zeros(' num2str(length(mdl.constraints) * 2) ', ' num2str(nq) ');\n']);

%% the dCc matrices
for ijoint = mdl.joints
    jpart = mdl.parts{ijoint};
    for iq = 1:length(jpart.parent.q)
        fullid = [jpart.name '_' jpart.parent.q{iq}];
        fprintf(file_id, [fullid ' = [' jpart.getsymvel{1, iq} '; ' jpart.getsymvel{2, iq} '; ' jpart.getsymvel{3, iq} ']; \n']);
    end
end

for icons = mdl.constraints
    jpart = mdl.parts{icons};
    for iq = 1:length(jpart.parent.q)
        fullid = [jpart.name '_1_' jpart.parent.q{iq}];
        fprintf(file_id, [fullid ' = [' jpart.getsymvel1{1, iq} '; ' jpart.getsymvel1{2, iq} '; ' jpart.getsymvel1{3, iq} ']; \n']);
        fullid = [jpart.name '_2_' jpart.child.q{iq}];
        fprintf(file_id, [fullid ' = [' jpart.getsymvel2{1, iq} '; ' jpart.getsymvel2{2, iq} '; ' jpart.getsymvel2{3, iq} ']; \n']);
    end
end

%% the constraint matrix dDc
for icons = 1:length(mdl.constraints)
    jpart = mdl.parts{mdl.constraints(icons)};
    for iq = 1:length(jpart.parent.q)
        fullid = [jpart.name '_1_' jpart.parent.q{iq}];
        fprintf(file_id, ['dDc(' num2str(icons * 2 - 1) ':' num2str(icons * 2) ', ' num2str(jpart.parent.qid(iq)) ') = ' fullid '(1:2);\n']);
    end
    jpart = jpart.parent;
    while ~strcmp(jpart.type, 'WORLD')
        for iq = 1:length(jpart.parent.q)
            fullid = [jpart.name '_' jpart.parent.q{iq}];
            fprintf(file_id, ['dDc(' num2str(icons * 2 - 1) ':' num2str(icons * 2) ', ' num2str(jpart.parent.qid(iq)) ') = ' fullid '(1:2);\n']);
        end
        jpart = jpart.parent;
    end
end

for icons = 1:length(mdl.constraints)
    jpart = mdl.parts{mdl.constraints(icons)};
    for iq = 1:length(jpart.parent.q)
        fullid = [jpart.name '_2_' jpart.child.q{iq}];
        fprintf(file_id, ['dDc(' num2str(icons * 2 - 1) ':' num2str(icons * 2) ', ' num2str(jpart.child.qid(iq)) ') = ' ...
            'dDc(' num2str(icons * 2 - 1) ':' num2str(icons * 2) ', ' num2str(jpart.child.qid(iq)) ') - ' fullid '(1:2);\n']);
    end  
    jpart = jpart.child;
    while ~strcmp(jpart.type, 'WORLD')
        for iq = 1:length(jpart.parent.q)
            fullid = [jpart.name '_' jpart.parent.q{iq}];
            fprintf(file_id, ['dDc(' num2str(icons * 2 - 1) ':' num2str(icons * 2) ', ' num2str(jpart.parent.qid(iq)) ') = ' ...
                'dDc(' num2str(icons * 2 - 1) ':' num2str(icons * 2) ', ' num2str(jpart.parent.qid(iq)) ') - ' fullid '(1:2);\n']);
        end
        jpart = jpart.parent;
    end
end

%% the ddT marix
for ijoint = mdl.joints
    jpart = mdl.parts{ijoint};
    for iq = 1:length(jpart.parent.q)
        fullid = [jpart.name '_' jpart.parent.q{iq}];
        fprintf(file_id, [fullid ' = [' jpart.getsymacc{1, iq} '; ' jpart.getsymacc{2, iq} '; ' jpart.getsymacc{3, iq} ']; \n']);
    end
end

for icons = mdl.constraints
    jpart = mdl.parts{icons};
    for iq = 1:length(jpart.parent.q)
        fullid = [jpart.name '_1_' jpart.parent.q{iq}];
        fprintf(file_id, [fullid ' = [' jpart.getsymacc1{1, iq} '; ' jpart.getsymacc1{2, iq} '; ' jpart.getsymacc1{3, iq} ']; \n']);
        fullid = [jpart.name '_2_' jpart.child.q{iq}];
        fprintf(file_id, [fullid ' = [' jpart.getsymacc2{1, iq} '; ' jpart.getsymacc2{2, iq} '; ' jpart.getsymacc2{3, iq} ']; \n']);
    end
end

%% the constraint matrix ddDc
for icons = 1:length(mdl.constraints)
    jpart = mdl.parts{mdl.constraints(icons)};
    for iq = 1:length(jpart.parent.q)
        fullid = [jpart.name '_1_' jpart.parent.q{iq}];
        fprintf(file_id, ['ddDc(' num2str(icons * 2 - 1) ':' num2str(icons * 2) ', ' num2str(jpart.parent.qid(iq)) ') = ' fullid '(1:2);\n']);
    end
    jpart = jpart.parent;
    while ~strcmp(jpart.type, 'WORLD')
        for iq = 1:length(jpart.parent.q)
            fullid = [jpart.name '_' jpart.parent.q{iq}];
            fprintf(file_id, ['ddDc(' num2str(icons * 2 - 1) ':' num2str(icons * 2) ', ' num2str(jpart.parent.qid(iq)) ') = ' fullid '(1:2);\n']);
        end
        jpart = jpart.parent;
    end
end

for icons = 1:length(mdl.constraints)
    jpart = mdl.parts{mdl.constraints(icons)};
    for iq = 1:length(jpart.parent.q)
        fullid = [jpart.name '_2_' jpart.child.q{iq}];
        fprintf(file_id, ['ddDc(' num2str(icons * 2 - 1) ':' num2str(icons * 2) ', ' num2str(jpart.child.qid(iq)) ') = ' ...
            'ddDc(' num2str(icons * 2 - 1) ':' num2str(icons * 2) ', ' num2str(jpart.child.qid(iq)) ') - ' fullid '(1:2);\n']);
    end  
    jpart = jpart.child;
    while ~strcmp(jpart.type, 'WORLD')
        for iq = 1:length(jpart.parent.q)
            fullid = [jpart.name '_' jpart.parent.q{iq}];
            fprintf(file_id, ['ddDc(' num2str(icons * 2 - 1) ':' num2str(icons * 2) ', ' num2str(jpart.parent.qid(iq)) ') = ' ...
                'ddDc(' num2str(icons * 2 - 1) ':' num2str(icons * 2) ', ' num2str(jpart.parent.qid(iq)) ') - ' fullid '(1:2);\n']);
        end
        jpart = jpart.parent;
    end
end

fclose(file_id);
end

