classdef motorcontroller
    %CONTROLLER Summary of this class goes here
    %   Detailed explanation goes here
    
    properties
        motors % joints to which the controller applies
        points % points to which external forces applies
        cid % controller id
        cons % constants that are used by the controller
        s = 0 % controler states that are integrated
        s0 = [] % initial state
        sid % states id
        rec = 0 % output values that are recorded in the controller
        recid % recorded output id
        name % name of the control
    end
    
    methods
        function writecontroller(c, ctype, mdl)
            % make the T matrix
            file_id = fopen([ctype.name '_control.m'], 'w'); % open file
            fprintf(file_id, ['function [F ds rec_out] = ' c.name '_control(t, q, dq, cons, s, rec_in, Tj, Tm, Tp, dTj, dTm, dTp, M)\n']); % write file header
            fprintf(file_id, ['F = zeros(' num2str(mdl.nq) ', 1); \n']);
                        
            ctype.writebody(file_id);
            
            % loop all the motors
            for iM = 1:length(c.motors)
                fprintf(file_id, ['F(' num2str(c.motors.qid) ') = F(' num2str(c.motors.qid) ') + M(' num2str(iM) '); \n']);
                if ~isempty(c.motors.parent.qid)
                    fprintf(file_id, ['F(' num2str(c.motors.parent.qid) ') = F(' num2str(c.motors.parent.qid) ') - M(' num2str(iM) '); \n']);
                end
            end
            
            if c.s == 0;
                fprintf(file_id, 'ds = []; \n');
            end
            if c.rec == 0;
                fprintf(file_id, 'rec_out = []; \n');
            end
            
            fclose(file_id);
        end
    end
    
end

