function [normstep] = normstep(stepdata, steps)
%NORMSTEP Normalizes multiple steps and puts them in a matrix
%  IN: stepdata: (i.e. jointangle)
%      steps: frame on which a step initializes
%  OUT: a matrix with the normalized steps

%% normalized staps
normstep = zeros(100, length(steps)-1);
for i = 1:length(steps)-1
    nFrames = steps(i+1) - steps(i);
    x1 = 0:1/nFrames:1;
    x2 = 0.01:0.01:1;
    yangle = stepdata(steps(i):steps(i+1));
    normstep(:,i) = interp1(x1, yangle, x2);
end
end

