function [dx rec_out events] = equations_of_motion(t, x, t_all, x_all, rec, N, dt, simcons) 
%#codegen 
q_dep = [2 4]; 
q_ind = [1 3]; 
q = x(1:4); 
dq = zeros(4,1); 
dq(q_ind) = x(5:6); 
s = []; 

[dDc ddDc] = Cmatrices(q, dq, simcons.p_in, simcons.c_in); 

dCm = [0 0;0 0;0 0;0 0]; 
ddCm = [0 0 0 0;0 0 0 0;0 0 0 0;0 0 0 0]; 
dCm(q_ind, :) = [1 0;0 1]; 
dCm(q_dep, :) = dDc(:,q_dep)\-dDc(:,q_ind); 
dq = dCm * dq(q_ind); 
[dDc ddDc] = Cmatrices(q, dq, simcons.p_in, simcons.c_in); 

ddCm(q_dep, :) = dDc(:,q_dep)\-ddDc; 
[Tj Tm Tp dTj dTm dTp ddTm] = Tmatrices(q, dq, simcons.p_in); 

F = zeros(4, 1); 
ds = []; 
rec_out = zeros(3, 1); 

events = zeros(1, 1); 
[Fc, ~, rec_out([1 2 3])] = contactforce_control(t, N, dt, q, dq, t_all, x_all, simcons.control.c1, s, rec, Tj, Tm, Tp, dTj, dTm, dTp, simcons.M); 
F = F + Fc; 
[Fc, ~, ~] = gravity_control(t, N, dt, q, dq, t_all, x_all, simcons.control.c2, s, rec, Tj, Tm, Tp, dTj, dTm, dTp, simcons.M); 
F = F + Fc; 

ddq = (dCm' * dTm' * simcons.M * dTm * dCm) \ (dCm' * (F - dTm' * (simcons.M * (ddTm * dq + dTm * ddCm * dq)))); 
dx = [dq; ddq; ds]; 

