% directory of the files
simdir = 'results';

%% run optimizations for normal walking
for i = 1:5
   runpso_reflex
end

optfiles = {};
d = dir([simdir filesep 'human_reflex*']);
for i = 1:length(d)
    d(i).name
    if isempty(strfind(d(i).name, '_mdl.mat')) % select the files not containing the model
        optfiles = [optfiles d(i).name];
    end
end

%% find the best fitness
for ifile = 1:length(optfiles)
    load([simdir filesep optfiles{ifile}])
    [~, fitness(ifile)] = p.overalbestpos(p.iterations);
end
[~, bestFile] = max(fitness);

%% load and save as walking_new
bestName = optfiles{bestFile};
load([simdir filesep bestName(1:end-4) '_mdl.mat'])

mdl.t = [0 10];
mdl.dt = 0.0005;

save walking_new mdl

%% run optimization with controlers
for i = 1:5
    runpso_anklesupport(1, 'ferris_support');
    runpso_anklesupport(1, 'ffgaitpatternankle');
    runpso_anklesupport(1, 'nosupport');
end
