classdef floatjoint < joint
    %FLOATJOINT creates a floating joint
    %   Detailed explanation goes here
    
    properties
    end
    
    methods
        function j = floatjoint(varargin)
            for iargin = 1:2:nargin
                eval(['j.' varargin{iargin} ' = varargin{iargin + 1};']);
            end
            j.q = {[j.name '_x'], [j.name '_y'], [j.name '_q']};
            j.dq = {[j.name '_dx'], [j.name '_dy'], [j.name '_dq']};
        end
        
        function childpos = getchildpos(j, cname)
            childpos = { ...
                ['l_' cname ' * -sin(theta_' cname ' + ' j.q{3} ')']; ...
                ['l_' cname ' * cos(theta_' cname ' + ' j.q{3} ')']; ...
                j.q{3}};
        end
        
        function childvel = getchildvel(j, cname)
            childvel = { ...
                '1', '0', ['l_' cname ' * -cos(theta_' cname ' + ' j.q{3} ')']; ...
                '0', '1', ['l_' cname ' * -sin(theta_' cname ' + ' j.q{3} ')']; ...
                '0', '0', '1' };
        end
        
        function childacc = getchildacc(j, cname)
            childacc = { ...
                '0', '0', [j.dq{1} ' * l_' cname ' *  sin(theta_' cname ' + ' j.q{3} ')']; ...
                '0', '0', [j.dq{1} ' * l_' cname ' * -cos(theta_' cname ' + ' j.q{3} ')']; ...
                '0', '0', '0'};
        end
        
        function symposout = getsympos(j)
            symposout = j.parent.getchildpos(j.name);
            symposout{1} = [symposout{1} ' + ' j.q{1}];
            symposout{2} = [symposout{2} ' + ' j.q{2}];
            symposout{3} = '0';
        end
        
        function symvelout = getsymvel(j)
            symvelout = j.parent.getchildvel(j.name);
            symvelout{3, 3} = '0';
        end
        
        function symaccout = getsymacc(j)
            symaccout = j.parent.getchildacc(j.name);
            symaccout{3, 3} = '0';
        end
    end    
end

