classdef joint < part
    %JOINT Summary of this class goes here
    %   Detailed explanation goes here
    
    properties
        q0
        dq0
    end
    
    methods
        function j = joint
            j.type = 'JOINT';
            j.color = [0.5 0.5 0.5];
        end
        
        function [p0] = getinitposchild(j, child)
            dpos = child.pos - j.pos;
            l = (dpos(1)^2 + dpos(2)^2)^0.5;
            theta = atan2(-dpos(1), dpos(2));
            p0 = [l theta];
        end
        
        function setshape(j)
            [x y] = cylinder(j.drawsize * 0.8, 16);
            n = convhull(x, y);
            j.shape = [x(n) y(n)];
        end
    end
    
end

