classdef part < handle
    %PART Summary of this class goes here
    %   Detailed explanation goes here
    
    properties (SetObservable)
        pos = [0; 0; 0]
        name = ''
        parent
        parentname
        child
        childname
        type
        q
        dq
        qid
        Tid
        shape = [.1 0; 0 .1; -.1 0; 0 -.1]
        drawsize = .1
        fill
        color = 'k';
        layer = 0;
    end
    
    methods
        function p = part
            addlistener(p,'parent','PostSet',@p.parentassigned);
            addlistener(p,'child','PostSet',@p.childassigned);
        end
        
        function makefill(p, parentfig)
            p.fill = fill3(0, 0, p.layer, p.color, 'Parent', parentfig);
            p.setfill(p.pos);
        end
        
        function setfill(p, cpos)
            R = [cos(cpos(3)) sin(cpos(3)); -sin(cpos(3)) cos(cpos(3))];
            transshape = p.shape * R + repmat([cpos(1) cpos(2)], size(p.shape, 1), 1);
            set(p.fill, 'XData', transshape(:, 1), 'YData', transshape(:, 2), 'ZData', ones(size(transshape, 1), 1) * p.layer);
        end
        
        function parentassigned(p, src, evnt)
            if isempty(p.parent.child);
                p.parent.child{1} = p;
            else
                p.parent.child{end+1} = p;
            end
        end
        
        function childassigned(p, src, evnt)
            if strcmp(p.type, 'CONSTRAINT')
                if isempty(p.child.child);
                    p.child.child{1} = p;
                else
                    p.child.child{end+1} = p;
                end
            end
        end
        
        function p0 = getinitpos(p)
            p0 = p.parent.getinitposchild(p);
        end
    end
    
end

