% This script gives an example on how to use the PSO optimization script
% Wietse van Dijk (w.vandijk@tudelft.nl, 2012)

% We make a new PSO optimization:
% The function we like to minimize is 'examplefunc', this function
% takes one vector as an imput and outputs an errorcode (scalar, 0 for no 
% errors), and a fitness (scalar).
% The lower bound of the input vector is set by 'posmin', and the upper bound
% is set by 'posmax'
p = pso('costfunc', @examplefun, 'posmin', [-1 -1 -1], 'posmax', [1 1 1]);

% If we like the set more properties we can do that as follows:
p.set('iterations', 80, 'popsize', 60, 'output', {'graphic'});
% For a detailed explanaition of the properties see the PSO script

% Run the optimization
p.run;

% The found optimum
[x_opt, fit_opt] = p.overalbestpos(p.iterations);
disp(['optimal value: ' num2str(fit_opt) ' @:' mat2str(squeeze(x_opt))]);